<template>
  <div v-if="display" class="overlay flex justify-center items-center w-full fixed top-0 left-0">
    <dialog open class="modal-content rounded-lg p-4 relative" :style="{ width: width, height: height }">
      <div class="w-full h-6 relative">
        <div v-if="Boolean(withClose)" class="right-0 top-0 absolute cursor-pointer" @click="withClose()">
          <Close />
        </div>
      </div>
      <div v-if="warning || success" class="w-full flex justify-center mb-6">
        <Warning v-if="warning" />
        <Success v-if="success" />
      </div>
      <p v-if="title" class="title mb-5">{{ title }}</p>
      <div v-if="desc" class="desc"><span :v-html="desc"></span></div>
      <slot></slot>
    </dialog>
  </div>
</template>

<script>
const Close = () => import('~/components/Icons/close');
const Warning = () => import('~/components/Icons/warning');
const Success = () => import('~/components/Icons/success');
export default {
  components: {
    Warning,
    Close,
    Success,
  },
  props: {
    width: {
      type: String,
      default: '',
    },
    height: {
      type: String,
      default: '',
    },
    title: {
      type: String,
      default: '',
    },
    desc: {
      type: String,
      default: '',
    },
    warning: {
      type: Boolean,
      default: false,
    },
    success: {
      type: Boolean,
      default: false,
    },
    withClose: {
      type: Function,
      default: () => {},
    },
    display: {
      type: Boolean,
      default: false,
    },
  },
  methods: {
    close() {
      this.withClose;
    },
  },
};
</script>

<style lang="scss" scoped>
.overlay {
  background-color: $black-transparent;
  height: 100vh;
}
.modal-content {
  background-color: $white;
  width: 400px;
  max-height: calc(100vh - 200px);
  color: $black-alt;
}
.title {
  font-weight: 600;
  font-size: 18px;
  line-height: 27px;
  color: $black-alt;
  text-align: center;
}
.desc {
  font-size: 14px;
  line-height: 20px;
  color: $black-alt;
  text-align: center;
}
</style>
